=== debian/changelog ===
openorienteering-mapper (0.7.0-1) unstable; urgency=medium

  * New upstream release
  * Add Build-Depends on libgdal-dev
  * Update fix-help-data-dir.patch
  * Do not build with -mno-rla on mips64el, no longer needed
  * Remove extra license file and replace it with a symlink
  * Strip RPATH from /usr/bin/Mapper
  * Bump Standards-Version to 4.1.0, no changes

 -- Graham Inggs <ginggs@debian.org>  Mon, 11 Sep 2017 14:11:05 +0000

openorienteering-mapper (0.6.8-3) unstable; urgency=medium

  * Build with -mno-lra on mips64el to avoid FTBFS, see #871514

 -- Graham Inggs <ginggs@debian.org>  Thu, 31 Aug 2017 15:41:19 +0000

openorienteering-mapper (0.6.8-2) unstable; urgency=medium

  * Upload to unstable, fixes build with GCC 7 (Closes: #871820)
  * Add myself to Uploaders
  * Remove duplicate .desktop entry and icons (Closes: #853952)
  * Use secure URIs for VCS fields
  * Switch to debhelper compat level 10
  * Update debian/copyright
  * Bump Standards-Version to 4.0.1, no further changes
  * Drop start wrapper that set QT_SELECT, no longer required,
    fixes opening files with spaces in their names (Closes: #872291)
  * Enable all build-time tests again, fixed upstream

 -- Graham Inggs <ginggs@debian.org>  Thu, 17 Aug 2017 12:41:15 +0000

openorienteering-mapper (0.6.8-1) experimental; urgency=medium

  * [6d69f6] New upstream release

 -- Gaudenz Steinlin <gaudenz@debian.org>  Thu, 16 Mar 2017 17:18:31 +0100
