=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

PKGDIR = $(CURDIR)/debian/openorienteering-mapper

# main packaging script based on dh7 syntax
%:
	dh $@

# debmake generated override targets
# This is example for Cmake (See http://bugs.debian.org/641051 )
override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	-DMapper_BUILD_QT=OFF \
	-DMapper_BUILD_CLIPPER=OFF \
	-DMapper_BUILD_PROJ=OFF \
	-DMapper_BUILD_PACKAGE=OFF \
	-DMapper_AUTORUN_UNIT_TESTS=OFF \
	-DMapper_AUTORUN_SYSTEM_TESTS=OFF

override_dh_auto_install:
	dh_auto_install
	# remove extra license file and replace it with a symlink
	rm -f $(PKGDIR)/usr/share/openorienteering-mapper/doc/common-licenses/GPL-3.txt
	ln -s /usr/share/common-licenses/GPL-3 $(PKGDIR)/usr/share/openorienteering-mapper/doc/common-licenses/GPL-3.txt
	# strip RPATH from /usr/bin/Mapper
	/usr/bin/chrpath -d $(PKGDIR)/usr/bin/Mapper

override_dh_auto_test:
	# The tests need a running X server, so use Xvfb to run the tests in automated
	# build environments.
	cd obj-$(DEB_HOST_GNU_TYPE) ; xvfb-run /usr/bin/ctest --force-new-ctest-process -j1 --extra-verbose
